---
title: ChildNode.replaceWith()
slug: Web/API/ChildNode/replaceWith
tags:
  - API
  - DOM
  - Method
  - Node
  - Reference
---
<div>{{APIRef("DOM")}}</div>

<p>The <code><strong>ChildNode.replaceWith()</strong></code> method replaces this <code>ChildNode</code> in the children list of its parent with a set of {{domxref("Node")}} or {{domxref("DOMString")}} objects. {{domxref("DOMString")}} objects are inserted as equivalent {{domxref("Text")}} nodes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">[Throws, Unscopable]
void ChildNode.replaceWith((Node or DOMString)... nodes);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
	<dt><code>nodes</code></dt>
	<dd>A set of {{domxref("Node")}} or {{domxref("DOMString")}} objects to replace.</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<ul>
	<li>{{domxref("HierarchyRequestError")}}: Node cannot be inserted at the specified point in the hierarchy.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Using_replaceWith">Using <code>replaceWith()</code></h3>

<pre class="brush: js notranslate">var parent = document.createElement("div");
var child = document.createElement("p");
parent.appendChild(child);
var span = document.createElement("span");

child.replaceWith(span);

console.log(parent.outerHTML);
// "&lt;div&gt;&lt;span&gt;&lt;/span&gt;&lt;/div&gt;"
</pre>

<h3 id="ChildNode.replaceWith_is_unscopable"><code>ChildNode.replaceWith()</code> is unscopable</h3>

<p>The <code>replaceWith()</code> method is not scoped into the <code>with</code> statement. See {{jsxref("Symbol.unscopables")}} for more information.</p>

<pre class="brush: js notranslate">with(node) {
  replaceWith("foo");
}
// ReferenceError: replaceWith is not defined </pre>

<h2 id="Polyfill">Polyfill</h2>

<p>You can polyfill the <code>replaceWith()</code> method in Internet Explorer 10+ and higher with the following code:</p>

<pre class="brush: js notranslate">function ReplaceWithPolyfill() {
  'use-strict'; // For safari, and IE &gt; 10
  var parent = this.parentNode, i = arguments.length, currentNode;
  if (!parent) return;
  if (!i) // if there are no arguments
    parent.removeChild(this);
  while (i--) { // i-- decrements i and returns the value of i before the decrement
    currentNode = arguments[i];
    if (typeof currentNode !== 'object'){
      currentNode = this.ownerDocument.createTextNode(currentNode);
    } else if (currentNode.parentNode){
      currentNode.parentNode.removeChild(currentNode);
    }
    // the value of "i" below is after the decrement
    if (!i) // if currentNode is the first argument (currentNode === arguments[0])
      parent.replaceChild(currentNode, this);
    else // if currentNode isn't the first
      parent.insertBefore(currentNode, this.nextSibling);
  }
}
if (!Element.prototype.replaceWith)
    Element.prototype.replaceWith = ReplaceWithPolyfill;
if (!CharacterData.prototype.replaceWith)
    CharacterData.prototype.replaceWith = ReplaceWithPolyfill;
if (!DocumentType.prototype.replaceWith)
    DocumentType.prototype.replaceWith = ReplaceWithPolyfill;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('DOM WHATWG', '#dom-childnode-replacewith', 'ChildNode.replacewith()')}}</td>
			<td>{{Spec2('DOM WHATWG')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ChildNode.replaceWith")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>{{domxref("ChildNode")}} and {{domxref("ParentNode")}}</li>
	<li>{{domxref("Node.replaceChild()")}}</li>
	<li>{{domxref("NodeList")}}</li>
</ul>
